MODULE PreparedRoutines
    !Prepared routines to use in CoBlox
    TASK PERS tooldata tPen:=[TRUE,[[0.0824584,50.6977,126.878],[0.5,-0.5,-0.5,-0.5]],[0.24,[8.7,12.3,49.2],[1,0,0,0],0.00021,0.00024,0.00009]];
    PERS num nAnswer;
    PERS speeddata vWriteSpeed:=[50,200,1000,1000];
    PERS wobjdata wPaper:=[FALSE,TRUE,"",[[-251.755,-257.942,53.3774],[0.745408,0.0011914,0.00200694,-0.666605]],[[0,0,0],[1,0,0,0]]];

    PROC SignPattern()
        TPErase;
        !Ask the user before signing
        TPReadFK nAnswer,stQuestion,stEmpty,stEmpty,stEmpty,stAnswer1,stAnswer2\MaxTime:=60;
        IF nAnswer=4 THEN
            !Answer 1
            !Move on top of paper
            MoveJ Offs(pMidOfPaper,0,0,100),v500,z10,tPen\WObj:=wPaper;
            SignPattern_Person;
            SignPattern_Heart;
            SignPattern_SAY;
            !Move on top of paper
            MoveJ Offs(pMidOfPaper,0,0,100),v500,z10,tPen\WObj:=wPaper;
        ELSEIF nAnswer=5 THEN
            !Answer 2
            Place_pen;
            ExitCycle;
        ELSE
            stop;
        ENDIF
    ERROR
        !In case nowbody will answer - select answer 2
        IF ERRNO=ERR_TP_MAXTIME THEN
            nAnswer:=5;
            TRYNEXT;
        ENDIF
    ENDPROC


    PROC SignPattern_Person()
        MoveL Offs(pP100,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pP100,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pP101,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP102,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP103,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP104,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pP105,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP106,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP107,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP108,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP109,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP110,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pP111,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP112,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP113,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP114,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pP100,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pP100,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        !Head of the person
        MoveL Offs(pP115,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pP115,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveC pP116,pP117,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveC pP118,pP119,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL Offs(pP119,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveJ Offs(pMidOfPaper,0,0,10),v500,z10,tPen\WObj:=wPaper;
    ENDPROC

    PROC SignPattern_Heart()
        MoveJ Offs(pMidOfPaper,0,0,10),v500,z10,tPen\WObj:=wPaper;
        !MoveL pMidOfPaper,vWriteSpeed,fine,tPen;
        MoveL Offs(pH100,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pH100,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveC pH101,pH102,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pH103,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pH104,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveC pH105,pH100,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL Offs(pH100,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveJ Offs(pMidOfPaper,0,0,10),v500,z10,tPen\WObj:=wPaper;
    ENDPROC

    PROC SignPattern_SAY()
        MoveJ Offs(pMidOfPaper,0,0,10),v500,z10,tPen\WObj:=wPaper;
        !MoveL pMidOfPaper,vWriteSpeed,fine,tPen;
        MoveL Offs(pS100,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS100,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS101,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS102,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS103,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS104,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS105,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS106,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS107,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS108,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS109,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS110,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS111,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS112,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS113,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS114,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS105,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL Offs(pS105,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pS115,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS115,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS116,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS117,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS118,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS119,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS120,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS121,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS122,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL Offs(pS122,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pS123,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS123,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS124,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS125,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS126,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS127,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS128,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS129,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS130,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS131,vWriteSpeed,z5,tPen\WObj:=wPaper;
        MoveL pS123,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS132,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS133,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS134,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS135,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS136,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS137,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS138,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS139,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS140,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS141,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pS141,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pS142,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS142,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS143,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS144,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS145,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS146,vWriteSpeed,z0,tPen\WObj:=wPaper;
        MoveL pS147,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS148,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS149,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS150,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS151,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS152,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS153,vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS154,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS155,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS156,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL Offs(pS156,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL Offs(pS157,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
        MoveL pS157,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS158,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS159,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS160,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS161,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS162,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS163,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS164,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL pS165,vWriteSpeed,z1,tPen\WObj:=wPaper;
        MoveL Offs(pS165,0,0,10),vWriteSpeed,fine,tPen\WObj:=wPaper;
    ENDPROC

    PROC Pick_pen()
        !Proc to pic the pen
        g_JogOut;
        MoveJ RelTool(pPickPen,-50,0,-50),v500,z10,tPen;
        MoveL pPickPen,v100,fine,tPen;
        g_GripIn\holdForce:=20;
        MoveL RelTool(pPickPen,0,0,-10),v100,z10,tPen;
        MoveL RelTool(pPickPen,0,0,-100),v500,z10,tPen;
    ENDPROC

    PROC Place_pen()
        !Proc to place the pen
        MoveJ RelTool(pPickPen,0,0,-100),v500,z10,tPen;
        MoveL RelTool(pPickPen,0,0,-17),v300,z1,tPen;
        MoveL RelTool(pPickPen,0,0,-1),v30,fine,tPen;
        MoveL pPickPen,v10,fine,tPen;
        g_JogOut;
        MoveL RelTool(pPickPen,0,0,-100),v500,z10,tPen;
        MoveL RelTool(pPickPen,-50,0,-100),v500,z10,tPen;
    ENDPROC

ENDMODULE